/*************************    DEPTH FIRST EXPLORATION     ******************************/
/**   Test on U-turns, when we arrive at a leaf of the exploration tree */
/** Discontinuities of the walk */

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define N 8
void explore(int i);
void chemin(int d, int a);
void pause(void);
void putpixel(int xe, int ye, Uint32 couleur);
Uint32 getpixel(int xe, int ye);
void circle( int xo, int yo, int R, Uint32 couleur);
void filldisc(int xo, int yo, int R,Uint32 couleur);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void fleche(int x1, int y1, int x2, int y2, Uint32 c);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
SDL_Surface * ecran; Uint32 blanc,color[9];  SDL_Color couleurnoire={0,0,0};
SDL_Surface *texte;  SDL_Rect position;TTF_Font *police=NULL;char chiffre[2000];
int x[N],y[N],v[N][N],nbv[N],dejavu[N],icolor,compteuri,ptdepart;

int main(int argc, char ** argv)
{  int i,j;
   SDL_Init(SDL_INIT_VIDEO);
   ecran=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   blanc=SDL_MapRGB(ecran->format,255,255,255);
   color[0]=SDL_MapRGB(ecran->format,0,0,0);
   color[1]=SDL_MapRGB(ecran->format,255,0,0);
   color[4]=SDL_MapRGB(ecran->format,150,50,150);
   color[2]=SDL_MapRGB(ecran->format,0,250,0);
   color[5]=SDL_MapRGB(ecran->format,150,200,150);
   color[3]=SDL_MapRGB(ecran->format,0,0,250);
   color[6]=SDL_MapRGB(ecran->format,150,150,200);
   color[7]=SDL_MapRGB(ecran->format,255,255,0);
   color[8]=SDL_MapRGB(ecran->format,200,200,200);
   SDL_FillRect(ecran,0,blanc);
   TTF_Init();  police=TTF_OpenFont("times.ttf",20);
/**********    conditions initiales    ****************/
x[0]=200;y[0]=40;  x[1]=100;y[1]=200;  x[2]=400;y[2]=40;  x[3]=300;y[3]=400;
x[4]=100;y[4]=400;  x[5]=400;y[5]=200;  x[6]=240;y[6]=300;  x[7]=200;y[7]=200;
v[0][0]=1;v[0][1]=2;v[0][2]=5;v[0][3]=7;  v[1][0]=0;v[1][1]=4;v[1][2]=7;   v[2][0]=0;
v[3][0]=4;v[3][1]=5;v[3][2]=6;  v[4][0]=1;v[4][1]=3;v[4][2]=6;v[4][3]=7;
v[5][0]=0;v[5][1]=3;v[5][2]=6; v[6][0]=3;v[6][1]=4;v[6][2]=5; v[7][0]=0;v[7][1]=1;v[7][2]=4;
nbv[0]=4;nbv[1]=3;nbv[2]=1;nbv[3]=3;nbv[4]=4;nbv[5]=3;nbv[6]=3;nbv[7]=3;
/**************   dessin du graphe    *****************/
for(i=0;i<N;i++)
  {
   for(j=0;j<nbv[i];j++)  linewithwidth(x[i],y[i],x[v[i][j]],y[v[i][j]],1,color[8]);
   sprintf( chiffre,"%d",i);
   texte=TTF_RenderText_Solid(police,chiffre,couleurnoire);
   position.x=x[i]+15; position.y=y[i]-2;
   SDL_BlitSurface(texte,NULL,ecran,&position);
  }
SDL_Flip(ecran); pause();
/**************     exploration     ********************/
ptdepart=0; icolor=1;
explore(ptdepart);
SDL_Flip(ecran); pause();  TTF_CloseFont(police); TTF_Quit();  return 0;
}

/*******************    fonction de visite     *************************/
void explore(int i)
{ int j,voisin,compteur;
   dejavu[i]=1; compteuri++;
   sprintf( chiffre,"%d",i);
   texte=TTF_RenderText_Solid(police,chiffre,couleurnoire);
   position.x=30+20*compteuri; position.y=450;
   SDL_BlitSurface(texte,NULL,ecran,&position);
   compteur=0;
   for(j=0;j<nbv[i];j++)
     { voisin=v[i][j];
        if (dejavu[voisin]==0)
         { compteur++;
            linewithwidth(x[i],y[i],x[voisin],y[voisin],icolor+1,color[icolor]);
            SDL_Flip(ecran); pause();
            explore(voisin);
         }
     }
if (compteur==0) icolor+=1;
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 couleur)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(ecran->pixels)+xe+ye*ecran->w;    *numerocase=couleur;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(ecran->pixels)+xe+ye*ecran->w;   return (*numerocase);
}


void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est pas nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}

void circle( int xo, int yo, int R, Uint32 couleur)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, couleur);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,couleur);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,couleur);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, couleur);
         }
       if (xo+R<800 && xo+R>=0 && yo>=0 && yo<600) putpixel(xo+R,yo,couleur);
       if (xo-R<800 && xo-R>=0 && yo>=0 && yo<600) putpixel(xo-R,yo, couleur);
  }

void filldisc( int xo, int yo, int R, Uint32 couleur)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,couleur);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, couleur);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,couleur);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,couleur);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,couleur);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, couleur);
  }
/**  ligne en marches d'escalier */
void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     y+=pasy;
                                     if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			     residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;
	                              		        if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			                                    }
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
               residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;
                                              if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                             }
             }
}


